if RequiredScript == "lib/units/equipment/sentry_gun/sentrygunbrain" then
	function SentryGunBrain:_choose_focus_enemy(t)
		local delay = 0.1
		local my_tracker = self._unit:movement():nav_tracker()
		local chk_vis_func = my_tracker.check_visibility
		local my_pos = self._m_head_object_pos
		for e_key, enemy_data in pairs(managers.enemy:all_enemies()) do
			self._AI_data.detected_enemies[e_key] = nil
			local enemy_unit = enemy_data.unit
			local is_hostage = enemy_unit:brain()._current_logic_name == "trade"
			if not is_hostage then
				if chk_vis_func(my_tracker, enemy_unit:movement():nav_tracker()) then
					local enemy_pos = enemy_unit:movement():m_head_pos()
					local enemy_vec = my_pos - enemy_pos
					local distance = mvector3.normalize(enemy_vec)
					if distance <= 5000 then
						local ray = World:raycast("ray", my_pos, enemy_pos, "slot_mask", self._visibility_slotmask, "ray_type", "ai_vision", "report")
						if not ray then
							local is_shield = enemy_unit:base()._tweak_table == "shield"
							local spin = enemy_vec:to_polar_with_reference(enemy_unit:movement():m_rot():y(), math.UP).spin
							local facing_shield = is_shield and math.abs(spin) < 60
							if not facing_shield then
								local world_slotmask = managers.slot:get_mask("world_geometry")
								local target_blocked = World:raycast("ray", my_pos, enemy_pos, "slot_mask", world_slotmask)
								if not target_blocked then
									local new_data = self:_create_enemy_detection_data(enemy_unit)
									new_data.verified_t = t
									new_data.verified = true
									self._AI_data.detected_enemies[e_key] = new_data
								end
							end
						end
					end
				end
			end
		end
		local focus_enemy, focus_enemy_prio
		for _, focus_data in pairs(self._AI_data.detected_enemies) do
			local dis = mvector3.distance(my_pos, focus_data.unit:movement():m_head_pos())
			local dis_var = math.ceil(dis/100)
			if not focus_enemy_prio or dis_var < focus_enemy_prio then
				focus_enemy_prio = dis_var
				focus_enemy = focus_data
			end
		end
		if focus_enemy then
			local attention = { unit = focus_enemy.unit }
			self._ext_movement:set_attention(attention)
			self._AI_data.focus_enemy = focus_enemy
		end
		return delay
	end
	function SentryGunBrain:_check_fire(t)
		if Network:is_client() then
			if self._firing then
				self._unit:weapon():trigger_held(true, false)
			end
			return
		end
		local focus_enemy = self._AI_data.focus_enemy
		if focus_enemy and not self._ext_movement:warming_up(t) then
			if self._firing then
				self._unit:weapon():trigger_held(false, true)
			else
				local tmp_vec1 = Vector3()
				mvector3.direction(tmp_vec1, self._eye_object_pos, focus_enemy.m_com)
				if mvector3.dot(tmp_vec1, self._ext_movement:m_head_fwd()) > tweak_data.weapon.sentry_gun.KEEP_FIRE_ANGLE then
					self._unit:weapon():start_autofire()
					self._unit:weapon():trigger_held(false, true)
					self._firing = true
					self._unit:network():send("cop_allow_fire")
				end
			end
		elseif self._firing then
			self._unit:weapon():stop_autofire()
			self._firing = false
			self._unit:network():send("cop_forbid_fire")
		end
	end
	function SentryGunBrain:synch_allow_fire(state)
		if state and not self._firing then
			self._unit:weapon():start_autofire()
			self._unit:weapon():trigger_held(true, false)
		elseif not state then
			if self._firing then
				self._unit:weapon():stop_autofire()
			end
		end
		self._firing = state
	end
end

if RequiredScript == "lib/units/weapons/raycastweaponbase" then
	function RaycastWeaponBase:set_real_ammo(ammo)
		self._ammo_total = ammo
		self._ammo_remaining_in_clip = math.min(self._ammo_max_per_clip, ammo)
		self._ammo_max = math.max(self._ammo_max, ammo)
	end
end

if RequiredScript == "lib/units/equipment/sentry_gun/sentrygundamage" then
	function SentryGunDamage:damage_melee(attack_data)
		if PlayerDamage:_look_for_friendly_fire(attack_data.attacker_unit) then
			local player_weapon = attack_data.attacker_unit:inventory():equipped_unit():base()
			local player_ammo_fract = math.ceil(player_weapon._ammo_max/10)
			if player_weapon._ammo_total >= player_ammo_fract then
				local sentry_damage = self._unit:character_damage()
				if not sentry_damage._dead then
					local sentry_weapon = self._unit:weapon()
					if sentry_weapon._ammo_total < sentry_weapon._ammo_max or sentry_damage._health < sentry_damage._health_max then
						local new_player_ammo = player_weapon._ammo_total - player_ammo_fract
						local sent_ammo_per = sentry_weapon._ammo_total + math.ceil(sentry_weapon._ammo_max/5)
						local new_sent_ammo = math.min(sent_ammo_per, sentry_weapon._ammo_max)
						local sent_health_per = sentry_damage._health + math.ceil(sentry_damage._health_max/5)
						local new_sent_health = math.min(sent_health_per, sentry_damage._health_max)
						sentry_weapon:set_ammo(new_sent_ammo)
						sentry_damage:set_health(new_sent_health)
						player_weapon:set_real_ammo(new_player_ammo)
						managers.hud:set_ammo_amount(player_weapon:ammo_info())
						self._unit:sound_source():post_event("turret_alert")
					end
				end
			end
		end
	end
end